-- Changes for differential expression.


-- default value null
ALTER TABLE ANALYSIS_RESULT_SET add column QVALUE_THRESHOLD_FOR_STORAGE DOUBLE;

-- add new table supporting pvalue distributions
create table PVALUE_DISTRIBUTION (ID BIGINT not null auto_increment, NUM_BINS INTEGER not null, BIN_COUNTS BLOB not null, primary key (ID));
alter table ANALYSIS_RESULT_SET add column PVALUE_DISTRIBUTION_FK BIGINT unique;
alter table ANALYSIS_RESULT_SET add index FKC510E6634F13DFD5 (PVALUE_DISTRIBUTION_FK), add constraint FKC510E6634F13DFD5 foreign key (PVALUE_DISTRIBUTION_FK) references PVALUE_DISTRIBUTION (ID);

-- change column name in DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT to be easier to work with in code. Do in two steps so we have both columns, briefly:
-- first add new column, RESULT_SET_FK
ALTER TABLE DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT add column RESULT_SET_FK BIGINT not null;
UPDATE DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT set RESULT_SET_FK = EXPRESSION_ANALYSIS_RESULT_SET_FK;
alter table DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT add index DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT_RESULT_SET_FKC (RESULT_SET_FK), add constraint DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT_RESULT_SET_FKC foreign key (RESULT_SET_FK) references ANALYSIS_RESULT_SET (ID);
-- re-run that update as necessary until code is switched:
UPDATE DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT set RESULT_SET_FK = EXPRESSION_ANALYSIS_RESULT_SET_FK where RESULT_SET_FK IS NULL;

-- same for hit lists
ALTER TABLE HIT_LIST_SIZE add column RESULT_SET_FK BIGINT not null;
set FOREIGN_KEY_CHECKS = 0;
alter table HIT_LIST_SIZE add index HIT_LIST_SIZE_RESULT_SET_FKC (RESULT_SET_FK), add constraint HIT_LIST_SIZE_RESULT_SET_FKC foreign key (RESULT_SET_FK) references ANALYSIS_RESULT_SET (ID);
set FOREIGN_KEY_CHECKs = 1;
UPDATE HIT_LIST_SIZE set RESULT_SET_FK = EXPRESSION_ANALYSIS_RESULT_SET_FK where RESULT_SET_FK is null; -- run this as needed up to final rollout.

--
create table META_ANALYSES2RESULT_SETS_INCLUDED (META_ANALYSES_FK BIGINT not null, RESULT_SETS_INCLUDED_FK BIGINT not null, primary key (META_ANALYSES_FK, RESULT_SETS_INCLUDED_FK));
alter table META_ANALYSES2RESULT_SETS_INCLUDED add index EXPRESSION_ANALYSIS_RESULT_SET_META_ANALYSES_FKC (META_ANALYSES_FK), add constraint EXPRESSION_ANALYSIS_RESULT_SET_META_ANALYSES_FKC foreign key (META_ANALYSES_FK) references ANALYSIS (ID);
alter table META_ANALYSES2RESULT_SETS_INCLUDED add index FK58643060635B349F (RESULT_SETS_INCLUDED_FK), add constraint FK58643060635B349F foreign key (RESULT_SETS_INCLUDED_FK) references ANALYSIS_RESULT_SET (ID);
insert into META_ANALYSES2RESULT_SETS_INCLUDED (META_ANALYSES_FK,RESULT_SETS_INCLUDED_FK) select GENE_DIFFERENTIAL_EXPRESSION_META_ANALYSES_FK,RESULT_SETS_INCLUDED_FK from GENE_DIFFERENTIAL_EXPRESSION_META_ANALYSES2RESULT_SETS_INCLU;

-- when all is well, drop EXPRESSION_EXPERIMENT_RESULT_SET_FK column
ALTER TABLE DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT DROP KEY DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT_EXPRESSION_ANALYSISC;
ALTER TABLE DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT DROP FOREIGN KEY DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT_EXPRESSION_ANALYSISC;
ALTER TABLE DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT drop column EXPRESSION_EXPERIMENT_RESULT_SET_FK;

ALTER TABLE HIT_LIST_SIZE DROP KEY HIT_SIZE_EXPRESSION_ANALYSIS_RESULT_SET_FKC;
ALTER TABLE HIT_LIST_SIZE DROP FOREIGN KEY DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT_EXPRESSION_ANALYSISC;
ALTER TABLE HIT_LIST_SIZE drop column HIT_LIST_SIZE_RESULT_SET_FK;

-- no longer needed.
drop table GENE_DIFFERENTIAL_EXPRESSION_META_ANALYSES2RESULT_SETS_INCLU;

--- Now, delete all results that are above the threshold we want to use by default.
DELETE c,r from DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT r inner join CONTRAST c ON c.DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT_FK=r.ID WHERE r.PVALUE >= 0.05;

-- drop more unneded columns 
alter table RAT_PROBE_CO_EXPRESSION drop key PROBE2_PROBE_COEXPRESSION_METRIC_FKC;
alter table OTHER_PROBE_CO_EXPRESSION drop key PROBE2_PROBE_COEXPRESSION_METRIC_FKC;
alter table HUMAN_PROBE_CO_EXPRESSION drop key PROBE2_PROBE_COEXPRESSION_METRIC_FKC;
alter table MOUSE_PROBE_CO_EXPRESSION drop key PROBE2_PROBE_COEXPRESSION_METRIC_FKC;
alter table RAT_PROBE_CO_EXPRESSION drop column METRIC_FK;
alter table OTHER_PROBE_CO_EXPRESSION drop column METRIC_FK;
alter table HUMAN_PROBE_CO_EXPRESSION drop column METRIC_FK;
alter table MOUSE_PROBE_CO_EXPRESSION drop column METRIC_FK;